// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: VelocityTimeParametersResponse.proto

package ru.omnicomm.pegasus.messaging.data.responses;

public final class VelocityTimeParametersResponseParser {
  private VelocityTimeParametersResponseParser() {}
  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistry registry) {
  }
  public static final class VelocityTimeParametersResponse extends
      com.google.protobuf.GeneratedMessage {
    // Use VelocityTimeParametersResponse.newBuilder() to construct.
    private VelocityTimeParametersResponse() {
      initFields();
    }
    private VelocityTimeParametersResponse(boolean noInit) {}
    
    private static final VelocityTimeParametersResponse defaultInstance;
    public static VelocityTimeParametersResponse getDefaultInstance() {
      return defaultInstance;
    }
    
    public VelocityTimeParametersResponse getDefaultInstanceForType() {
      return defaultInstance;
    }
    
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.internal_static_ru_omnicomm_pegasus_messaging_data_responses_VelocityTimeParametersResponse_descriptor;
    }
    
    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.internal_static_ru_omnicomm_pegasus_messaging_data_responses_VelocityTimeParametersResponse_fieldAccessorTable;
    }
    
    public enum State
        implements com.google.protobuf.ProtocolMessageEnum {
      NORMAL(0, 0),
      LAST(1, 1),
      DEFECTIVE(2, 2),
      ;
      
      
      public final int getNumber() { return value; }
      
      public static State valueOf(int value) {
        switch (value) {
          case 0: return NORMAL;
          case 1: return LAST;
          case 2: return DEFECTIVE;
          default: return null;
        }
      }
      
      public static com.google.protobuf.Internal.EnumLiteMap<State>
          internalGetValueMap() {
        return internalValueMap;
      }
      private static com.google.protobuf.Internal.EnumLiteMap<State>
          internalValueMap =
            new com.google.protobuf.Internal.EnumLiteMap<State>() {
              public State findValueByNumber(int number) {
                return State.valueOf(number)
      ;        }
            };
      
      public final com.google.protobuf.Descriptors.EnumValueDescriptor
          getValueDescriptor() {
        return getDescriptor().getValues().get(index);
      }
      public final com.google.protobuf.Descriptors.EnumDescriptor
          getDescriptorForType() {
        return getDescriptor();
      }
      public static final com.google.protobuf.Descriptors.EnumDescriptor
          getDescriptor() {
        return ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.getDescriptor().getEnumTypes().get(0);
      }
      
      private static final State[] VALUES = {
        NORMAL, LAST, DEFECTIVE, 
      };
      public static State valueOf(
          com.google.protobuf.Descriptors.EnumValueDescriptor desc) {
        if (desc.getType() != getDescriptor()) {
          throw new java.lang.IllegalArgumentException(
            "EnumValueDescriptor is not for this type.");
        }
        return VALUES[desc.getIndex()];
      }
      private final int index;
      private final int value;
      private State(int index, int value) {
        this.index = index;
        this.value = value;
      }
      
      static {
        ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.getDescriptor();
      }
      
      // @@protoc_insertion_point(enum_scope:ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponse.State)
    }
    
    public static final class Row extends
        com.google.protobuf.GeneratedMessage {
      // Use Row.newBuilder() to construct.
      private Row() {
        initFields();
      }
      private Row(boolean noInit) {}
      
      private static final Row defaultInstance;
      public static Row getDefaultInstance() {
        return defaultInstance;
      }
      
      public Row getDefaultInstanceForType() {
        return defaultInstance;
      }
      
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.internal_static_ru_omnicomm_pegasus_messaging_data_responses_VelocityTimeParametersResponse_Row_descriptor;
      }
      
      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.internal_static_ru_omnicomm_pegasus_messaging_data_responses_VelocityTimeParametersResponse_Row_fieldAccessorTable;
      }
      
      // required string vehicleId = 101;
      public static final int VEHICLEID_FIELD_NUMBER = 101;
      private boolean hasVehicleId;
      private java.lang.String vehicleId_ = "";
      public boolean hasVehicleId() { return hasVehicleId; }
      public java.lang.String getVehicleId() { return vehicleId_; }
      
      // required double mileage = 102;
      public static final int MILEAGE_FIELD_NUMBER = 102;
      private boolean hasMileage;
      private double mileage_ = 0D;
      public boolean hasMileage() { return hasMileage; }
      public double getMileage() { return mileage_; }
      
      // required double averageVelocity = 103;
      public static final int AVERAGEVELOCITY_FIELD_NUMBER = 103;
      private boolean hasAverageVelocity;
      private double averageVelocity_ = 0D;
      public boolean hasAverageVelocity() { return hasAverageVelocity; }
      public double getAverageVelocity() { return averageVelocity_; }
      
      // required double maxVelocity = 104;
      public static final int MAXVELOCITY_FIELD_NUMBER = 104;
      private boolean hasMaxVelocity;
      private double maxVelocity_ = 0D;
      public boolean hasMaxVelocity() { return hasMaxVelocity; }
      public double getMaxVelocity() { return maxVelocity_; }
      
      // required double motionTime = 105;
      public static final int MOTIONTIME_FIELD_NUMBER = 105;
      private boolean hasMotionTime;
      private double motionTime_ = 0D;
      public boolean hasMotionTime() { return hasMotionTime; }
      public double getMotionTime() { return motionTime_; }
      
      // required double stoppingTime = 106;
      public static final int STOPPINGTIME_FIELD_NUMBER = 106;
      private boolean hasStoppingTime;
      private double stoppingTime_ = 0D;
      public boolean hasStoppingTime() { return hasStoppingTime; }
      public double getStoppingTime() { return stoppingTime_; }
      
      // required double absenceTime = 107;
      public static final int ABSENCETIME_FIELD_NUMBER = 107;
      private boolean hasAbsenceTime;
      private double absenceTime_ = 0D;
      public boolean hasAbsenceTime() { return hasAbsenceTime; }
      public double getAbsenceTime() { return absenceTime_; }
      
      private void initFields() {
      }
      public final boolean isInitialized() {
        if (!hasVehicleId) return false;
        if (!hasMileage) return false;
        if (!hasAverageVelocity) return false;
        if (!hasMaxVelocity) return false;
        if (!hasMotionTime) return false;
        if (!hasStoppingTime) return false;
        if (!hasAbsenceTime) return false;
        return true;
      }
      
      public void writeTo(com.google.protobuf.CodedOutputStream output)
                          throws java.io.IOException {
        getSerializedSize();
        if (hasVehicleId()) {
          output.writeString(101, getVehicleId());
        }
        if (hasMileage()) {
          output.writeDouble(102, getMileage());
        }
        if (hasAverageVelocity()) {
          output.writeDouble(103, getAverageVelocity());
        }
        if (hasMaxVelocity()) {
          output.writeDouble(104, getMaxVelocity());
        }
        if (hasMotionTime()) {
          output.writeDouble(105, getMotionTime());
        }
        if (hasStoppingTime()) {
          output.writeDouble(106, getStoppingTime());
        }
        if (hasAbsenceTime()) {
          output.writeDouble(107, getAbsenceTime());
        }
        getUnknownFields().writeTo(output);
      }
      
      private int memoizedSerializedSize = -1;
      public int getSerializedSize() {
        int size = memoizedSerializedSize;
        if (size != -1) return size;
      
        size = 0;
        if (hasVehicleId()) {
          size += com.google.protobuf.CodedOutputStream
            .computeStringSize(101, getVehicleId());
        }
        if (hasMileage()) {
          size += com.google.protobuf.CodedOutputStream
            .computeDoubleSize(102, getMileage());
        }
        if (hasAverageVelocity()) {
          size += com.google.protobuf.CodedOutputStream
            .computeDoubleSize(103, getAverageVelocity());
        }
        if (hasMaxVelocity()) {
          size += com.google.protobuf.CodedOutputStream
            .computeDoubleSize(104, getMaxVelocity());
        }
        if (hasMotionTime()) {
          size += com.google.protobuf.CodedOutputStream
            .computeDoubleSize(105, getMotionTime());
        }
        if (hasStoppingTime()) {
          size += com.google.protobuf.CodedOutputStream
            .computeDoubleSize(106, getStoppingTime());
        }
        if (hasAbsenceTime()) {
          size += com.google.protobuf.CodedOutputStream
            .computeDoubleSize(107, getAbsenceTime());
        }
        size += getUnknownFields().getSerializedSize();
        memoizedSerializedSize = size;
        return size;
      }
      
      public static ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row parseFrom(
          com.google.protobuf.ByteString data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row parseFrom(
          com.google.protobuf.ByteString data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data, extensionRegistry)
                 .buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row parseFrom(byte[] data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row parseFrom(
          byte[] data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data, extensionRegistry)
                 .buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row parseFrom(java.io.InputStream input)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row parseFrom(
          java.io.InputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input, extensionRegistry)
                 .buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row parseDelimitedFrom(java.io.InputStream input)
          throws java.io.IOException {
        Builder builder = newBuilder();
        if (builder.mergeDelimitedFrom(input)) {
          return builder.buildParsed();
        } else {
          return null;
        }
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row parseDelimitedFrom(
          java.io.InputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        Builder builder = newBuilder();
        if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
          return builder.buildParsed();
        } else {
          return null;
        }
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row parseFrom(
          com.google.protobuf.CodedInputStream input)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row parseFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input, extensionRegistry)
                 .buildParsed();
      }
      
      public static Builder newBuilder() { return Builder.create(); }
      public Builder newBuilderForType() { return newBuilder(); }
      public static Builder newBuilder(ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row prototype) {
        return newBuilder().mergeFrom(prototype);
      }
      public Builder toBuilder() { return newBuilder(this); }
      
      public static final class Builder extends
          com.google.protobuf.GeneratedMessage.Builder<Builder> {
        private ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row result;
        
        // Construct using ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row.newBuilder()
        private Builder() {}
        
        private static Builder create() {
          Builder builder = new Builder();
          builder.result = new ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row();
          return builder;
        }
        
        protected ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row internalGetResult() {
          return result;
        }
        
        public Builder clear() {
          if (result == null) {
            throw new IllegalStateException(
              "Cannot call clear() after build().");
          }
          result = new ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row();
          return this;
        }
        
        public Builder clone() {
          return create().mergeFrom(result);
        }
        
        public com.google.protobuf.Descriptors.Descriptor
            getDescriptorForType() {
          return ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row.getDescriptor();
        }
        
        public ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row getDefaultInstanceForType() {
          return ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row.getDefaultInstance();
        }
        
        public boolean isInitialized() {
          return result.isInitialized();
        }
        public ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row build() {
          if (result != null && !isInitialized()) {
            throw newUninitializedMessageException(result);
          }
          return buildPartial();
        }
        
        private ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row buildParsed()
            throws com.google.protobuf.InvalidProtocolBufferException {
          if (!isInitialized()) {
            throw newUninitializedMessageException(
              result).asInvalidProtocolBufferException();
          }
          return buildPartial();
        }
        
        public ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row buildPartial() {
          if (result == null) {
            throw new IllegalStateException(
              "build() has already been called on this Builder.");
          }
          ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row returnMe = result;
          result = null;
          return returnMe;
        }
        
        public Builder mergeFrom(com.google.protobuf.Message other) {
          if (other instanceof ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row) {
            return mergeFrom((ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row)other);
          } else {
            super.mergeFrom(other);
            return this;
          }
        }
        
        public Builder mergeFrom(ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row other) {
          if (other == ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row.getDefaultInstance()) return this;
          if (other.hasVehicleId()) {
            setVehicleId(other.getVehicleId());
          }
          if (other.hasMileage()) {
            setMileage(other.getMileage());
          }
          if (other.hasAverageVelocity()) {
            setAverageVelocity(other.getAverageVelocity());
          }
          if (other.hasMaxVelocity()) {
            setMaxVelocity(other.getMaxVelocity());
          }
          if (other.hasMotionTime()) {
            setMotionTime(other.getMotionTime());
          }
          if (other.hasStoppingTime()) {
            setStoppingTime(other.getStoppingTime());
          }
          if (other.hasAbsenceTime()) {
            setAbsenceTime(other.getAbsenceTime());
          }
          this.mergeUnknownFields(other.getUnknownFields());
          return this;
        }
        
        public Builder mergeFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          com.google.protobuf.UnknownFieldSet.Builder unknownFields =
            com.google.protobuf.UnknownFieldSet.newBuilder(
              this.getUnknownFields());
          while (true) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                this.setUnknownFields(unknownFields.build());
                return this;
              default: {
                if (!parseUnknownField(input, unknownFields,
                                       extensionRegistry, tag)) {
                  this.setUnknownFields(unknownFields.build());
                  return this;
                }
                break;
              }
              case 810: {
                setVehicleId(input.readString());
                break;
              }
              case 817: {
                setMileage(input.readDouble());
                break;
              }
              case 825: {
                setAverageVelocity(input.readDouble());
                break;
              }
              case 833: {
                setMaxVelocity(input.readDouble());
                break;
              }
              case 841: {
                setMotionTime(input.readDouble());
                break;
              }
              case 849: {
                setStoppingTime(input.readDouble());
                break;
              }
              case 857: {
                setAbsenceTime(input.readDouble());
                break;
              }
            }
          }
        }
        
        
        // required string vehicleId = 101;
        public boolean hasVehicleId() {
          return result.hasVehicleId();
        }
        public java.lang.String getVehicleId() {
          return result.getVehicleId();
        }
        public Builder setVehicleId(java.lang.String value) {
          if (value == null) {
    throw new NullPointerException();
  }
  result.hasVehicleId = true;
          result.vehicleId_ = value;
          return this;
        }
        public Builder clearVehicleId() {
          result.hasVehicleId = false;
          result.vehicleId_ = getDefaultInstance().getVehicleId();
          return this;
        }
        
        // required double mileage = 102;
        public boolean hasMileage() {
          return result.hasMileage();
        }
        public double getMileage() {
          return result.getMileage();
        }
        public Builder setMileage(double value) {
          result.hasMileage = true;
          result.mileage_ = value;
          return this;
        }
        public Builder clearMileage() {
          result.hasMileage = false;
          result.mileage_ = 0D;
          return this;
        }
        
        // required double averageVelocity = 103;
        public boolean hasAverageVelocity() {
          return result.hasAverageVelocity();
        }
        public double getAverageVelocity() {
          return result.getAverageVelocity();
        }
        public Builder setAverageVelocity(double value) {
          result.hasAverageVelocity = true;
          result.averageVelocity_ = value;
          return this;
        }
        public Builder clearAverageVelocity() {
          result.hasAverageVelocity = false;
          result.averageVelocity_ = 0D;
          return this;
        }
        
        // required double maxVelocity = 104;
        public boolean hasMaxVelocity() {
          return result.hasMaxVelocity();
        }
        public double getMaxVelocity() {
          return result.getMaxVelocity();
        }
        public Builder setMaxVelocity(double value) {
          result.hasMaxVelocity = true;
          result.maxVelocity_ = value;
          return this;
        }
        public Builder clearMaxVelocity() {
          result.hasMaxVelocity = false;
          result.maxVelocity_ = 0D;
          return this;
        }
        
        // required double motionTime = 105;
        public boolean hasMotionTime() {
          return result.hasMotionTime();
        }
        public double getMotionTime() {
          return result.getMotionTime();
        }
        public Builder setMotionTime(double value) {
          result.hasMotionTime = true;
          result.motionTime_ = value;
          return this;
        }
        public Builder clearMotionTime() {
          result.hasMotionTime = false;
          result.motionTime_ = 0D;
          return this;
        }
        
        // required double stoppingTime = 106;
        public boolean hasStoppingTime() {
          return result.hasStoppingTime();
        }
        public double getStoppingTime() {
          return result.getStoppingTime();
        }
        public Builder setStoppingTime(double value) {
          result.hasStoppingTime = true;
          result.stoppingTime_ = value;
          return this;
        }
        public Builder clearStoppingTime() {
          result.hasStoppingTime = false;
          result.stoppingTime_ = 0D;
          return this;
        }
        
        // required double absenceTime = 107;
        public boolean hasAbsenceTime() {
          return result.hasAbsenceTime();
        }
        public double getAbsenceTime() {
          return result.getAbsenceTime();
        }
        public Builder setAbsenceTime(double value) {
          result.hasAbsenceTime = true;
          result.absenceTime_ = value;
          return this;
        }
        public Builder clearAbsenceTime() {
          result.hasAbsenceTime = false;
          result.absenceTime_ = 0D;
          return this;
        }
        
        // @@protoc_insertion_point(builder_scope:ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponse.Row)
      }
      
      static {
        defaultInstance = new Row(true);
        ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.internalForceInit();
        defaultInstance.initFields();
      }
      
      // @@protoc_insertion_point(class_scope:ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponse.Row)
    }
    
    // required int32 messageType = 2;
    public static final int MESSAGETYPE_FIELD_NUMBER = 2;
    private boolean hasMessageType;
    private int messageType_ = 0;
    public boolean hasMessageType() { return hasMessageType; }
    public int getMessageType() { return messageType_; }
    
    // optional string instanceId = 4;
    public static final int INSTANCEID_FIELD_NUMBER = 4;
    private boolean hasInstanceId;
    private java.lang.String instanceId_ = "";
    public boolean hasInstanceId() { return hasInstanceId; }
    public java.lang.String getInstanceId() { return instanceId_; }
    
    // repeated .ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponse.Row rows = 201;
    public static final int ROWS_FIELD_NUMBER = 201;
    private java.util.List<ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row> rows_ =
      java.util.Collections.emptyList();
    public java.util.List<ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row> getRowsList() {
      return rows_;
    }
    public int getRowsCount() { return rows_.size(); }
    public ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row getRows(int index) {
      return rows_.get(index);
    }
    
    // optional .ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponse.State blockState = 300;
    public static final int BLOCKSTATE_FIELD_NUMBER = 300;
    private boolean hasBlockState;
    private ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.State blockState_;
    public boolean hasBlockState() { return hasBlockState; }
    public ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.State getBlockState() { return blockState_; }
    
    // optional int32 blockNumber = 301;
    public static final int BLOCKNUMBER_FIELD_NUMBER = 301;
    private boolean hasBlockNumber;
    private int blockNumber_ = 0;
    public boolean hasBlockNumber() { return hasBlockNumber; }
    public int getBlockNumber() { return blockNumber_; }
    
    private void initFields() {
      blockState_ = ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.State.NORMAL;
    }
    public final boolean isInitialized() {
      if (!hasMessageType) return false;
      for (ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row element : getRowsList()) {
        if (!element.isInitialized()) return false;
      }
      return true;
    }
    
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (hasMessageType()) {
        output.writeInt32(2, getMessageType());
      }
      if (hasInstanceId()) {
        output.writeString(4, getInstanceId());
      }
      for (ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row element : getRowsList()) {
        output.writeMessage(201, element);
      }
      if (hasBlockState()) {
        output.writeEnum(300, getBlockState().getNumber());
      }
      if (hasBlockNumber()) {
        output.writeInt32(301, getBlockNumber());
      }
      getUnknownFields().writeTo(output);
    }
    
    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;
    
      size = 0;
      if (hasMessageType()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(2, getMessageType());
      }
      if (hasInstanceId()) {
        size += com.google.protobuf.CodedOutputStream
          .computeStringSize(4, getInstanceId());
      }
      for (ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row element : getRowsList()) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(201, element);
      }
      if (hasBlockState()) {
        size += com.google.protobuf.CodedOutputStream
          .computeEnumSize(300, getBlockState().getNumber());
      }
      if (hasBlockNumber()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(301, getBlockNumber());
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }
    
    public static ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    
    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }
    
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder> {
      private ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse result;
      
      // Construct using ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.newBuilder()
      private Builder() {}
      
      private static Builder create() {
        Builder builder = new Builder();
        builder.result = new ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse();
        return builder;
      }
      
      protected ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse internalGetResult() {
        return result;
      }
      
      public Builder clear() {
        if (result == null) {
          throw new IllegalStateException(
            "Cannot call clear() after build().");
        }
        result = new ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse();
        return this;
      }
      
      public Builder clone() {
        return create().mergeFrom(result);
      }
      
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.getDescriptor();
      }
      
      public ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse getDefaultInstanceForType() {
        return ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.getDefaultInstance();
      }
      
      public boolean isInitialized() {
        return result.isInitialized();
      }
      public ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse build() {
        if (result != null && !isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return buildPartial();
      }
      
      private ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse buildParsed()
          throws com.google.protobuf.InvalidProtocolBufferException {
        if (!isInitialized()) {
          throw newUninitializedMessageException(
            result).asInvalidProtocolBufferException();
        }
        return buildPartial();
      }
      
      public ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse buildPartial() {
        if (result == null) {
          throw new IllegalStateException(
            "build() has already been called on this Builder.");
        }
        if (result.rows_ != java.util.Collections.EMPTY_LIST) {
          result.rows_ =
            java.util.Collections.unmodifiableList(result.rows_);
        }
        ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse returnMe = result;
        result = null;
        return returnMe;
      }
      
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse) {
          return mergeFrom((ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }
      
      public Builder mergeFrom(ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse other) {
        if (other == ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.getDefaultInstance()) return this;
        if (other.hasMessageType()) {
          setMessageType(other.getMessageType());
        }
        if (other.hasInstanceId()) {
          setInstanceId(other.getInstanceId());
        }
        if (!other.rows_.isEmpty()) {
          if (result.rows_.isEmpty()) {
            result.rows_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row>();
          }
          result.rows_.addAll(other.rows_);
        }
        if (other.hasBlockState()) {
          setBlockState(other.getBlockState());
        }
        if (other.hasBlockNumber()) {
          setBlockNumber(other.getBlockNumber());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }
      
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder(
            this.getUnknownFields());
        while (true) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              this.setUnknownFields(unknownFields.build());
              return this;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                this.setUnknownFields(unknownFields.build());
                return this;
              }
              break;
            }
            case 16: {
              setMessageType(input.readInt32());
              break;
            }
            case 34: {
              setInstanceId(input.readString());
              break;
            }
            case 1610: {
              ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row.Builder subBuilder = ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row.newBuilder();
              input.readMessage(subBuilder, extensionRegistry);
              addRows(subBuilder.buildPartial());
              break;
            }
            case 2400: {
              int rawValue = input.readEnum();
              ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.State value = ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.State.valueOf(rawValue);
              if (value == null) {
                unknownFields.mergeVarintField(300, rawValue);
              } else {
                setBlockState(value);
              }
              break;
            }
            case 2408: {
              setBlockNumber(input.readInt32());
              break;
            }
          }
        }
      }
      
      
      // required int32 messageType = 2;
      public boolean hasMessageType() {
        return result.hasMessageType();
      }
      public int getMessageType() {
        return result.getMessageType();
      }
      public Builder setMessageType(int value) {
        result.hasMessageType = true;
        result.messageType_ = value;
        return this;
      }
      public Builder clearMessageType() {
        result.hasMessageType = false;
        result.messageType_ = 0;
        return this;
      }
      
      // optional string instanceId = 4;
      public boolean hasInstanceId() {
        return result.hasInstanceId();
      }
      public java.lang.String getInstanceId() {
        return result.getInstanceId();
      }
      public Builder setInstanceId(java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  result.hasInstanceId = true;
        result.instanceId_ = value;
        return this;
      }
      public Builder clearInstanceId() {
        result.hasInstanceId = false;
        result.instanceId_ = getDefaultInstance().getInstanceId();
        return this;
      }
      
      // repeated .ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponse.Row rows = 201;
      public java.util.List<ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row> getRowsList() {
        return java.util.Collections.unmodifiableList(result.rows_);
      }
      public int getRowsCount() {
        return result.getRowsCount();
      }
      public ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row getRows(int index) {
        return result.getRows(index);
      }
      public Builder setRows(int index, ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row value) {
        if (value == null) {
          throw new NullPointerException();
        }
        result.rows_.set(index, value);
        return this;
      }
      public Builder setRows(int index, ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row.Builder builderForValue) {
        result.rows_.set(index, builderForValue.build());
        return this;
      }
      public Builder addRows(ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row value) {
        if (value == null) {
          throw new NullPointerException();
        }
        if (result.rows_.isEmpty()) {
          result.rows_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row>();
        }
        result.rows_.add(value);
        return this;
      }
      public Builder addRows(ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row.Builder builderForValue) {
        if (result.rows_.isEmpty()) {
          result.rows_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row>();
        }
        result.rows_.add(builderForValue.build());
        return this;
      }
      public Builder addAllRows(
          java.lang.Iterable<? extends ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row> values) {
        if (result.rows_.isEmpty()) {
          result.rows_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row>();
        }
        super.addAll(values, result.rows_);
        return this;
      }
      public Builder clearRows() {
        result.rows_ = java.util.Collections.emptyList();
        return this;
      }
      
      // optional .ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponse.State blockState = 300;
      public boolean hasBlockState() {
        return result.hasBlockState();
      }
      public ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.State getBlockState() {
        return result.getBlockState();
      }
      public Builder setBlockState(ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.State value) {
        if (value == null) {
          throw new NullPointerException();
        }
        result.hasBlockState = true;
        result.blockState_ = value;
        return this;
      }
      public Builder clearBlockState() {
        result.hasBlockState = false;
        result.blockState_ = ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.State.NORMAL;
        return this;
      }
      
      // optional int32 blockNumber = 301;
      public boolean hasBlockNumber() {
        return result.hasBlockNumber();
      }
      public int getBlockNumber() {
        return result.getBlockNumber();
      }
      public Builder setBlockNumber(int value) {
        result.hasBlockNumber = true;
        result.blockNumber_ = value;
        return this;
      }
      public Builder clearBlockNumber() {
        result.hasBlockNumber = false;
        result.blockNumber_ = 0;
        return this;
      }
      
      // @@protoc_insertion_point(builder_scope:ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponse)
    }
    
    static {
      defaultInstance = new VelocityTimeParametersResponse(true);
      ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.internalForceInit();
      defaultInstance.initFields();
    }
    
    // @@protoc_insertion_point(class_scope:ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponse)
  }
  
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_ru_omnicomm_pegasus_messaging_data_responses_VelocityTimeParametersResponse_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_ru_omnicomm_pegasus_messaging_data_responses_VelocityTimeParametersResponse_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_ru_omnicomm_pegasus_messaging_data_responses_VelocityTimeParametersResponse_Row_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_ru_omnicomm_pegasus_messaging_data_responses_VelocityTimeParametersResponse_Row_fieldAccessorTable;
  
  public static com.google.protobuf.Descriptors.FileDescriptor
      getDescriptor() {
    return descriptor;
  }
  private static com.google.protobuf.Descriptors.FileDescriptor
      descriptor;
  static {
    java.lang.String[] descriptorData = {
      "\n$VelocityTimeParametersResponse.proto\022," +
      "ru.omnicomm.pegasus.messaging.data.respo" +
      "nses\"\360\003\n\036VelocityTimeParametersResponse\022" +
      "\023\n\013messageType\030\002 \002(\005\022\022\n\ninstanceId\030\004 \001(\t" +
      "\022_\n\004rows\030\311\001 \003(\0132P.ru.omnicomm.pegasus.me" +
      "ssaging.data.responses.VelocityTimeParam" +
      "etersResponse.Row\022g\n\nblockState\030\254\002 \001(\0162R" +
      ".ru.omnicomm.pegasus.messaging.data.resp" +
      "onses.VelocityTimeParametersResponse.Sta" +
      "te\022\024\n\013blockNumber\030\255\002 \001(\005\032\226\001\n\003Row\022\021\n\tvehi",
      "cleId\030e \002(\t\022\017\n\007mileage\030f \002(\001\022\027\n\017averageV" +
      "elocity\030g \002(\001\022\023\n\013maxVelocity\030h \002(\001\022\022\n\nmo" +
      "tionTime\030i \002(\001\022\024\n\014stoppingTime\030j \002(\001\022\023\n\013" +
      "absenceTime\030k \002(\001\",\n\005State\022\n\n\006NORMAL\020\000\022\010" +
      "\n\004LAST\020\001\022\r\n\tDEFECTIVE\020\002BT\n,ru.omnicomm.p" +
      "egasus.messaging.data.responsesB$Velocit" +
      "yTimeParametersResponseParser"
    };
    com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner assigner =
      new com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner() {
        public com.google.protobuf.ExtensionRegistry assignDescriptors(
            com.google.protobuf.Descriptors.FileDescriptor root) {
          descriptor = root;
          internal_static_ru_omnicomm_pegasus_messaging_data_responses_VelocityTimeParametersResponse_descriptor =
            getDescriptor().getMessageTypes().get(0);
          internal_static_ru_omnicomm_pegasus_messaging_data_responses_VelocityTimeParametersResponse_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_ru_omnicomm_pegasus_messaging_data_responses_VelocityTimeParametersResponse_descriptor,
              new java.lang.String[] { "MessageType", "InstanceId", "Rows", "BlockState", "BlockNumber", },
              ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.class,
              ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Builder.class);
          internal_static_ru_omnicomm_pegasus_messaging_data_responses_VelocityTimeParametersResponse_Row_descriptor =
            internal_static_ru_omnicomm_pegasus_messaging_data_responses_VelocityTimeParametersResponse_descriptor.getNestedTypes().get(0);
          internal_static_ru_omnicomm_pegasus_messaging_data_responses_VelocityTimeParametersResponse_Row_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_ru_omnicomm_pegasus_messaging_data_responses_VelocityTimeParametersResponse_Row_descriptor,
              new java.lang.String[] { "VehicleId", "Mileage", "AverageVelocity", "MaxVelocity", "MotionTime", "StoppingTime", "AbsenceTime", },
              ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row.class,
              ru.omnicomm.pegasus.messaging.data.responses.VelocityTimeParametersResponseParser.VelocityTimeParametersResponse.Row.Builder.class);
          return null;
        }
      };
    com.google.protobuf.Descriptors.FileDescriptor
      .internalBuildGeneratedFileFrom(descriptorData,
        new com.google.protobuf.Descriptors.FileDescriptor[] {
        }, assigner);
  }
  
  public static void internalForceInit() {}
  
  // @@protoc_insertion_point(outer_class_scope)
}
